<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_education".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderEducation".
 *
 * Columns in table "provider_education" available as properties of the model,
 * followed by relations of table "provider_education" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $education_type_id
 * @property integer $education_name_id
 * @property string $area_of_focus
 * @property integer $started_year
 * @property integer $graduation_year
 *
 * @property EducationName $educationName
 * @property EducationType $educationType
 * @property Provider $provider
 */
abstract class BaseProviderEducation extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_education';
    }

    public static function representingColumn()
    {
        return 'area_of_focus';
    }

    public function rules()
    {
        return array(
            array('provider_id, education_type_id, education_name_id, area_of_focus', 'required'),
            array('provider_id, education_type_id, education_name_id', 'numerical', 'integerOnly' => true),
            array('area_of_focus', 'length', 'max' => 100),
            array('id, provider_id, education_type_id, education_name_id, area_of_focus, graduation_year, '
                . 'started_year', 'safe', 'on' => 'search'),
            array('graduation_year, started_year', 'validYear'),
            array('graduation_year, started_year', 'numerical', 'min' => 1900, 'max' => date('Y'),
                'allowEmpty' => true),
            array('graduation_year, started_year', 'default', 'setOnEmpty' => true, 'value' => null),
        );
    }

    public function validYear()
    {
        if ($this->graduation_year == 'yyyy' || $this->graduation_year == '') {
            $this->graduation_year = null;
        }
        if ($this->started_year == 'yyyy' || $this->started_year == '') {
            $this->started_year = null;
        }
        if ($this->graduation_year != '') {
            if ($this->graduation_year < $this->started_year) {
                $this->addError('to_date', utf8_encode('Started Year cannot be after Graduation Year.'));
            }
        }
    }

    public function relations()
    {
        return array(
            'educationName' => array(self::BELONGS_TO, 'EducationName', 'education_name_id'),
            'educationType' => array(self::BELONGS_TO, 'EducationType', 'education_type_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'education_type_id' => Yii::t('app', 'Degree Achieved'),
            'education_name_id' => Yii::t('app', 'Name of School/Institution'),
            'area_of_focus' => Yii::t('app', 'Major'),
            'started_year' => Yii::t('app', 'Year Started'),
            'graduation_year' => Yii::t('app', 'Year Completed'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //this is to enable eager loading - looks like it's no good to add provider or educationName here
        $criteria->with = array('educationType');

        //$criteria->compare('id', $this->id);
        //$criteria->compare('provider_id', $this->provider_id);
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }

        $criteria->compare('education_type_id', $this->education_type_id);
        //$criteria->compare('education_name_id', $this->education_name_id);
        if (!intval($this->education_name_id) && is_string($this->education_name_id)
                && strlen($this->education_name_id) > 0) {
            $criteria->with[] = 'educationName';
            $criteria->addSearchCondition("educationName.name", $this->education_name_id, true);
        } else {
            $criteria->compare('education_name_id', $this->education_name_id);
        }
        //$criteria->compare('area_of_focus', $this->area_of_focus, true);
        $criteria->compare('t.started_year', $this->started_year, true);
        $criteria->compare('t.graduation_year', $this->graduation_year, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderEducation|ProviderEducations', $n);
    }

}
